%!TEX root = main.tex
\section{Methodology}
To analyse the overall performance of the Crossbred Algorithm, $n$ was incremented from 1 until 200 for $\mathbb{F}_2$, $\mathbb{F}_3$ and $\mathbb{F}_{7}$ for various ratios of $m$. We assume that all polynomial system of equations are homogeneous, of the highest possible degree and semi-regular.

In terms of the field sizes, $\mathbb{F}_2$ was chosen as a baseline to compare the other results to. $\mathbb{F}_3$ was chosen since it represents a very small field, but still larger than $\mathbb{F}_2$, and $\mathbb{F}_{7}$ represents larger field, hence, it represents a corner case. $\mathbb{F}_{127}$ was also considered, by when taking into account that we assume that the system is homogeneous with degree $q = 127$, even finding parameters for $n = 11$ was not feasible to due a very large degree of regularity.

% The results were obtained by first finding the optimal admissible parameters. The optimal parameters were found by iterating through a triple-nested loop. The outer loops iterates over $k = 1,\hdots,n$. For each value of $k$, iterate over $D$ from $d_{reg}(k),\hdots,d_{reg}(n)$. This upper limit was chosen as $D$ is at most $d_{reg}(n)$ over $m$ equations. Since we are assuming semi-regularity, if $\mathbb{F}_{q>2}$, we can calculate the degree of regularity by finding the first non-negative power of the Hilbert Series presented in Equation~\ref{eqn:hilbertfq}. If the system is in a $\mathbb{F}_2$, we instead use Equation~\ref{eqn:hilbertf2}. In the inner-most loop, we iterate over $d$ from $1,\hdots,D-1$. For each tuple $(D,d,k)$, its admissibility is checked with the appropriate admissibility series. If it is admissible, we calculate the complexity by substituting in the values of the tuple and values of $m$, $n$ and $q$ into the appropriate complexity estimate equation presented in the previous section. After exiting the triple-nested loop, we output the minimum complexity estimate obtained and the associated tuple.

The results were obtained by finding the optimal admissible parameters, which was done by iterating through all possible values of $D$, $d$ and $k$, similar to the Algorithm 3.5 named FindTradeOff in~\cite[p.10]{Faugere:2008hf5}. The referenced FindTradeOff algorithm was used to obtain optimal parameters for Hybrid-$F_5$
\footnote{This code can be found in \url{https://gitlab.com/manuscripts8624926/complexity-of-crossbred/crossbred-and-hybrid-f5-optimal-parameters-finder}}.

\section{Results}
\subsection[Results for m = 2n]{Results for \lowercase{m = 2n}}
% It was assumed that $m = 2n$. The results shown in Figure~\ref{fig:crossbred2n} behave as expected, whereby as $n$ increases, the complexity increases exponentially.

% \begin{figure}
%     \centering
%     \begin{tikzpicture}[trim axis left]
%         \begin{axis}[xmin = 1,xmax = 200, scale only axis, height=5cm,
%                 width=\linewidth,legend pos=north west, ymode=log, log basis y={2}, xlabel=$n$,ylabel=$\approx \mathcal{C}_{cross_{q}}$ Output]
%             \addplot[mark=none,color=red] table[x = n, y = c, col sep=comma]{data/m=2n/f_2.csv};
%             \addlegendentry{$\mathbb{F}_2$}
%             \addplot[mark=none,color=blue] table[x = n, y = c, col sep=comma]{data/m=2n/f_3.csv};
%             \addlegendentry{$\mathbb{F}_3$}
%             \addplot[mark=none,color=green] table[x = n, y = c, col sep=comma]{data/m=2n/f_7.csv};
%             \addlegendentry{$\mathbb{F}_{7}$}
%         \end{axis}
%     \end{tikzpicture}
%     \caption{Optimal Cost of Crossbred as $m = 2n$ increases}
%     \label{fig:crossbred2n}
% \end{figure}

% \subsubsection{Comparison to FES}
% To compare Crossbred and  FES, $n$ was enumerated from 1 till 200 and the complexity of FES complexity was calculated. Recall that for $\mathbb{F}_q$, the complexity of FES is $\log_q(n)q^n$. The results of this are plotted in Figure~\ref{fig:fes2n}.

% Even in $\mathbb{F}_2$, the difference between the complexities of Crossbred and FES may be considered irrelevant as it may be due to small missing factors in either complexity estimates. Hence, in this case, despite practical speed, the Crossbred algorithm does not provide an improved complexity estimate. This aligns with the previous results by~\cite{Vitse:2017cb}.

The results for $m = 2n$ are shown in Figure~\ref{fig:m2n}.

\begin{figure}
    \centering
    \begin{tikzpicture}[trim axis left]
        \begin{axis}[xmin = 1,xmax = 200, scale only axis, height=9cm,
                width=0.75\columnwidth,legend pos=north west, ymode=log, log basis y={2}, xlabel=$n$,ylabel= Cost of Running Algorithm]
            \addplot[mark=none,color=teal,dashdotted] table [x = n, y = c, col sep=comma]{data/m=2n/FES_f_2.csv};
            \addlegendentry{$\mathbb{F}_2$ FES}
            \addplot[mark=none, color=brown,dashdotted] table [x = n, y = c, col sep=comma]{data/m=2n/FES_f_3.csv};
            \addlegendentry{$\mathbb{F}_3$ FES}
            \addplot[mark=none, color=orange,dashdotted] table [x = n, y = c, col sep=comma]{data/m=2n/FES_f_7.csv};
            \addlegendentry{$\mathbb{F}_{7}$ FES}
            \addplot[mark=none, color=red] table [x = n, y = c, col sep=comma]{data/m=2n/f_2.csv};
            \addlegendentry{$\mathbb{F}_2$ Crossbred}
            \addplot[mark=none, color=blue] table [x = n, y = c, col sep=comma]{data/m=2n/f_3.csv};
            \addlegendentry{$\mathbb{F}_3$ Crossbred}
            \addplot[mark=none,color=green] table [x = n, y = c, col sep=comma]{data/m=2n/f_7.csv};
            \addlegendentry{$\mathbb{F}_{7}$ Crossbred}
            \addplot[mark=none,color=black,dashed] table [x = n, y = c, col sep=comma]{data/m=2n/HYBRID_f_2.csv};
            \addlegendentry{$\mathbb{F}_2$ Hybrid}
            \addplot[mark=none, color=gray,dashed] table [x = n, y = c, col sep=comma]{data/m=2n/HYBRID_f_3.csv};
            \addlegendentry{$\mathbb{F}_3$ Hybrid}
            \addplot[mark=none, color=purple,dashed] table [x = n, y = c, col sep=comma]{data/m=2n/HYBRID_f_7.csv};
            \addlegendentry{$\mathbb{F}_{7}$ Hybrid}
            \addplot[mark=none, color=olive,dashdotdotted] table [x = n, y = c, col sep=comma]{data/m=2n/FXL_f_2.csv};
            \addlegendentry{$\mathbb{F}_{2}$ FXL}
            \addplot[mark=none, color=cyan,dashdotdotted] table [x = n, y = c, col sep=comma]{data/m=2n/FXL_f_3.csv};
            \addlegendentry{$\mathbb{F}_{3}$ FXL}
            \addplot[mark=none, color=magenta,dashdotdotted] table [x = n, y = c, col sep=comma]{data/m=2n/FXL_f_7.csv};
            \addlegendentry{$\mathbb{F}_{7}$ FXL}
        \end{axis}
    \end{tikzpicture}
    \caption{Optimal Cost of Running Crossbred, FES, FXL and Hybrid-$F_5$ as $m = 2n$ increases.}
    \label{fig:m2n}
\end{figure}

In $\mathbb{F}_2$, the Crossbred algorithm clearly provides a better concrete complexity than FES for all fields, which falls in line with the results presented by \cite{Vitse:2017cb}.
However, In general, Crossbred provided no complexity improvement over Hybrid-$F_5$ and FXL.
However, it seems that FXL may outperform Crossbred for larger fields.

\subsection[Results for m = n + 1]{Results for \lowercase{m = n + 1}}

The results for $m = n+1$ are shown in Figure~\ref{fig:mn1}.

\begin{figure}
    \centering
    \begin{tikzpicture}[trim axis left]
        \begin{axis}[xmin = 1,xmax = 200, scale only axis, height=9cm,
                width=0.75\columnwidth,legend pos=north west, ymode=log, log basis y={2}, xlabel=$n$,ylabel= Cost of Running Algorithm]
            \addplot[mark=none,color=teal,dashdotted] table [x = n, y = c, col sep=comma]{data/m=n+1/FES_f_2.csv};
            \addlegendentry{$\mathbb{F}_2$ FES}
            \addplot[mark=none, color=brown,dashdotted] table [x = n, y = c, col sep=comma]{data/m=n+1/FES_f_3.csv};
            \addlegendentry{$\mathbb{F}_3$ FES}
            \addplot[mark=none, color=orange,dashdotted] table [x = n, y = c, col sep=comma]{data/m=n+1/FES_f_7.csv};
            \addlegendentry{$\mathbb{F}_{7}$ FES}
            \addplot[mark=none, color=red] table [x = n, y = c, col sep=comma]{data/m=n+1/f_2.csv};
            \addlegendentry{$\mathbb{F}_2$ Crossbred}
            \addplot[mark=none, color=blue] table [x = n, y = c, col sep=comma]{data/m=n+1/f_3.csv};
            \addlegendentry{$\mathbb{F}_3$ Crossbred}
            \addplot[mark=none,color=green] table [x = n, y = c, col sep=comma]{data/m=n+1/f_7.csv};
            \addlegendentry{$\mathbb{F}_{7}$ Crossbred}
            \addplot[mark=none,color=black,dashed] table [x = n, y = c, col sep=comma]{data/m=n+1/HYBRID_f_2.csv};
            \addlegendentry{$\mathbb{F}_3$ Hybrid}
            \addplot[mark=none, color=gray,dashed] table [x = n, y = c, col sep=comma]{data/m=n+1/HYBRID_f_3.csv};
            \addlegendentry{$\mathbb{F}_3$ Hybrid}
            \addplot[mark=none, color=purple,dashed] table [x = n, y = c, col sep=comma]{data/m=n+1/HYBRID_f_7.csv};
            \addlegendentry{$\mathbb{F}_{7}$ Hybrid}
            \addplot[mark=none, color=olive,dashdotdotted] table [x = n, y = c, col sep=comma]{data/m=n+1/FXL_f_2.csv};
            \addlegendentry{$\mathbb{F}_{2}$ FXL}
            \addplot[mark=none, color=olive,dashdotdotted] table [x = n, y = c, col sep=comma]{data/m=n+1/FXL_f_3.csv};
            \addlegendentry{$\mathbb{F}_{3}$ FXL}
            \addplot[mark=none, color=olive,dashdotdotted] table [x = n, y = c, col sep=comma]{data/m=n+1/FXL_f_7.csv};
            \addlegendentry{$\mathbb{F}_{7}$ FXL}
        \end{axis}
    \end{tikzpicture}
    \caption{Optimal Cost of Running Crossbred, FES, FXL and Hybrid-$F_5$ as $m = n + 1$ increases.}
    \label{fig:mn1}
\end{figure}

As the ratio of $m$ and $n$ decreases, Crossbred's complexity improvement over FES becomes small and may even be attributed to miscellanious missing terms in either complexity estimates.  Once again, Crossbred does not provide a complexity improvement over Hybrid-$F_5$ and FXL.
